<template>
  <div class="app-container calendar-list-container" v-loading.body="showLoadingBody">
    <div class="filter-container" ref="filter-container">
      <el-form ref="queryForm" :inline="inline" :model="listQuery" label-width="60px">
        <el-row>
          <el-col :span="6">
            <el-form-item label="描述">
              <el-input v-model.number="listQuery.activitiesName" placeholder="请输入描述"></el-input>
            </el-form-item>
          </el-col>
          <el-button class="filter-item" type="primary" v-waves icon="search" @click="handleFilter">搜索</el-button>
          <el-button class="filter-item" type="primary" style="float: right;" @click="handleCreate">+ 添加弹窗</el-button>
        </el-row>
      </el-form>
    </div>
    <el-table :key='tableKey' :data="list" border fit highlight-current-row
              style="width: 100%">
      <el-table-column
        type="index"
        align="center" label="序号" width="98">
      </el-table-column>
      <el-table-column width="200" align="center" label="描述">
        <template scope="scope">
          <span>{{scope.row.name}}</span>
        </template>
      </el-table-column>
      <el-table-column width="300" align="center" label="安卓跳转链接">
        <template scope="scope">
          <span>{{scope.row.url}}</span>
        </template>
      </el-table-column>
      <el-table-column width="300" align="center" label="苹果跳转链接">
        <template scope="scope">
          <span>{{scope.row.iosUrl}}</span>
        </template>
      </el-table-column>
      <el-table-column width="300" align="center" label="小程序跳转链接">
        <template scope="scope">
          <span>{{scope.row.purl}}</span>
        </template>
      </el-table-column>
      <el-table-column width="300" align="center" label="banner图片">
        <template scope="scope">
          <img :src="scope.row.picture" style="width:100%;max-height:100px;">
        </template>
      </el-table-column>
      <el-table-column align="center" label="排序">
        <template scope="scope">
          <span>{{scope.row.sort}}</span>
        </template>
      </el-table-column>
      <el-table-column width="250" align="center" label="创建时间">
        <template scope="scope">
          <span>{{scope.row.crtTimeStr}}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" label="状态">
        <template scope="scope">
          <span v-if="scope.row.status==1">上架</span>
          <span v-if="scope.row.status==2">下架</span>
        </template>
      </el-table-column>
      <el-table-column align="center" width="150" label="操作" fixed="right">
        <template scope="scope">
          <el-button size="small" class="el-button el-button--text el-button--small" @click="handleUpdate(scope.row)">
            编辑
          </el-button>
          <el-button size="small" class="el-button el-button--text el-button--small" @click="handleDown(scope.row)"
                     v-show="scope.row.status==1">下架
          </el-button>
          <el-button size="small" class="el-button el-button--text el-button--small" @click="handleUp(scope.row)"
                     v-show="scope.row.status==2">上架
          </el-button>
          <el-button class="el-button el-button--text el-button--small" size="small" @click="deleteHandler(scope.row)"
                     style="color:red;" v-show="scope.row.status==2">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <div v-show="!listLoading" class="pagination-container">
      <el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange"
                     :current-page.sync="listQuery.page" :page-sizes="[10,20,30,40,50]" :page-size="listQuery.limit"
                     layout="total, sizes, prev, pager, next, jumper" :total="total"></el-pagination>
    </div>
    <!-- banner modal弹窗 -->
    <el-dialog :title="modalTitle" :visible.sync="bannerDialogVisible">
      <el-form :model="form" :rules="rules" ref="form" label-width="90px">
        <el-form-item label="描述" prop="name">
          <el-input v-model="form.name" placeholder="请输入描述"></el-input>
        </el-form-item>
        <el-form-item label="上架时间">
          <el-radio-group v-model="form.up_name" size="medium">
            <el-radio-button label="不限"></el-radio-button>
            <el-radio-button label="自定义"></el-radio-button>
          </el-radio-group>
          <div style="display:inline-block" v-show="form.up_name=='自定义'">
            <el-date-picker v-model="form.starTimeStr" type="datetime" placeholder="开始时间"
                            value-format=" yyyy-MM-dd HH:mm" format="yyyy-MM-dd HH:mm"
                            :picker-options="pickerOptionsStart"></el-date-picker>
            <span> - </span>
            <el-date-picker v-model="form.endTimeStr" type="datetime" placeholder="结束时间"
                            value-format=" yyyy-MM-dd HH:mm" format="yyyy-MM-dd HH:mm"
                            :picker-options="pickerOptionsEnd"></el-date-picker>
          </div>
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input v-model="form.sort" placeholder="请输入排序"></el-input>
        </el-form-item>
        <el-form-item label="图片" prop="picture" :style="{display:'block'}">
          <el-upload
            class="avatar-uploader"
            :action="BASE_API+'/api/universal/file/app/unauth/admin/upload'"
            :show-file-list="false"
            :headers="getHeaderWithToken"
            :on-success="handleAvatarSuccess">
            <img v-if="$utils.isString(form.picture) && !$utils.isEmpty(form.picture)" :src="form.picture"
                 style="width:200px;max-height:200px;">
            <i v-else class="el-icon-plus avatar-uploader-icon"
               style="lineHeight:100px;width:100px;height: 100px;vertical-align: middle;"></i>
          </el-upload>
        </el-form-item>
        <el-form-item label="安卓跳转链接" prop="url">
          <el-input v-model="form.url" placeholder="请输入跳转链接"></el-input>
        </el-form-item>
        <el-form-item label="苹果跳转链接" prop="url">
          <el-input v-model="form.iosUrl" placeholder="请输入跳转链接"></el-input>
        </el-form-item>
        <el-form-item label="小程序跳转链接" prop="url">
          <el-input v-model="form.purl" placeholder="请输入跳转链接"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="cancelHandel">取 消</el-button>
        <el-button v-if="modalTitle=='创建'" type="primary" @click="create('form')">确 定</el-button>
        <el-button v-else type="primary" @click="update('form')">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import 'static/css/uploadImg.css';// 引入图片上传组件对话框

  import {
    formatDate
  } from 'utils/dateFormattor';

  import {
    toEast8Date,
    deepCopyDate,
    newEast8Date,
    convertDate2Str,
    timestamp2Date,
    getYMD_hm
  } from 'utils/dateUtils';

  import {
    getActivityList,
    getObj,
    addObj,
    editObj,
    delObj
  } from 'src/api/appManagement/selectedActivities';

  import rsCode from '../../../utils/rsCode';

  import {mapGetters} from 'vuex';
  import {
    getToken
  } from '../../../utils/auth';

  import Element1 from "../../admin/menu/components/element";
  import ElRow from "element-ui/packages/row/src/row";
  import ElCol from "element-ui/packages/col/src/col";

  export default {
    name: 'selectedActivities',
    components: {
      ElCol,
      ElRow,
      Element1
    },
    data() {
      return {
        tableKey: 0,
        modalTitle: "创建",
        BASE_API: process.env.BASE_API,
        bannerDialogVisible: false,//添加、编辑弹框
        showLoadingBody: false,
        form: {
          name: "",
          up_name: '自定义',
          starTimeStr: '',
          endTimeStr: '',
          sort: '',
          picture: '',
          url: '',
          iosUrl: '',
          purl:'',
        },
        listQuery: {
          page: 1,
          limit: 20,
          activitiesName: '',//描述

        },
        rules: {
          name: {
            type: 'string',
            required: true,
            message: '请输入弹窗描述',
            trigger: 'blur'
          },
          picture: {
            type: 'string',
            required: true,
            message: '请上传图片',
          },
          url: {
            type: 'string',
            required: true,
            message: '请输入链接',
            trigger: 'blur'
          },
          sort: {
            required: true,
            message: '请输入排序'
          }
        },
        pickerOptionsStart: {
          disabledDate(time) {
            return time.getTime() < Date.now() - 8.64e7;
          }
        },
        pickerOptionsEnd: {
          disabledDate: time => {
            const beginDateVal = new Date(this.form.starTimeStr).getTime()
            if (beginDateVal) {
              return time.getTime() < beginDateVal - 8.64e7
            }
          }
        },
        list: null,
        total: null,
        listLoading: true,
        inline: true,
      }
    },
    created() {
      this.getList();
    },
    computed: {
      ...mapGetters([
        'elements',
        'belong2Type'
      ]),
      getHeaderWithToken() {
        return {Authorization: getToken()};
      },
    },
    methods: {
      handleFilter() {
        this.listQuery.page = 1;
        this.$refs.queryForm.validate(valid => {
          if (valid) {
            this.getList();
          } else {
            return false;
          }
        });
      },
      handleSizeChange(val) {
        this.listQuery.limit = val;
        this.getList();
      },
      handleCurrentChange(val) {
        this.listQuery.page = val;
        this.getList();
      },
      /**
       * 添加
       * */
      handleCreate() {
        this.cleanForm();
        this.modalTitle = '创建';
        this.bannerDialogVisible = true;
      },
      /**
       * 操作-编辑
       * */
      handleUpdate(row) {
        this.modalTitle = '编辑';
        this.cleanForm();
        getObj(row.id).then(response => {
          var item = response.data;
          item.up_name = item.timeType == 0 ? '不限' : item.timeType == 1 ? '自定义' : '';
          if (item.startTime > 0 && item.timeType == 1) {
            item.starTimeStr = getYMD_hm(item.startTime);
          } else {
            item.starTimeStr = '';
          }
          if (item.endTime > 0 && item.timeType == 1) {
            item.endTimeStr = getYMD_hm(item.endTime);
          } else {
            item.endTimeStr = '';
          }
          this.form = item;
          this.bannerDialogVisible = true;
        })

      },
      /**
       * 弹框-取消
       * */
      cancelHandel() {
        this.cleanForm();
        this.bannerDialogVisible = false;
      },
      /**
       * 清空表单
       * */
      cleanForm() {
        this.form = {
          name: "",
          up_name: '自定义',
          starTimeStr: '',
          endTimeStr: '',
          sort: '',
          picture: '',
          url: '',
          sort: 0,
        }
      },
      /**
       * 获取banner列表数据
       * */
      getList() {
        this.listLoading = true;
        getActivityList(this.listQuery).then(response => {
          let totalCountRs = undefined;
          let listRs = undefined;
          if (!this.$utils.isEmpty(response.data.list) && this.$utils.isInteger(response.data.total)) {
            listRs = response.data.list;
            response.data.list.map(function (item) {
              item.crtTimeStr = timestamp2Date(item.crtTime);
              item.visible2 = false;
            });
            totalCountRs = response.data.total;
          }
          this.listLoading = false;
          this.list = listRs;
          this.total = totalCountRs;
        });
      },
      /**
       * 创建
       * */
      create(formName) {
        let that = this;
        const set = this.$refs;
        set[formName].validate(valid => {
          if (valid) {
            if (that.form.up_name == '自定义') {
              that.form.timeType = 1;
              that.form.startTime = new Date(this.form.starTimeStr).getTime();
              that.form.endTime = new Date(this.form.endTimeStr).getTime();
              if (new Date(this.form.endTimeStr).getTime() < new Date(this.form.starTimeStr).getTime()) {
                this.$notify({
                  title: '警告',
                  message: '结束时间不能小于起始时间',
                  type: 'warning',
                  duration: 2000
                });
                return false;
              }
            } else {
              that.form.timeType = 0;
            }
            that.form.status = 2;
            addObj(this.form).then(response => {
              if (response.status === 200) {
                this.bannerDialogVisible = false;
                this.$notify({
                  title: '成功',
                  message: '创建成功',
                  type: 'success',
                  duration: 2000
                });
                this.getList();
              } else {
                this.$notify({
                  title: '失败',
                  message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
                  type: 'error',
                  duration: 2000
                });
              }
            });
          } else {
            return false;
          }
        });
      },
      /**
       * 编辑-更新
       * */
      update(formName) {
        let that = this;
        const set = this.$refs;
        set[formName].validate(valid => {
          debugger
          if (valid) {
            if (that.form.up_name == '自定义') {
              that.form.timeType = 1;
              that.form.startTime = new Date(this.form.starTimeStr).getTime();
              that.form.endTime = new Date(this.form.endTimeStr).getTime();
              if (new Date(this.form.endTimeStr).getTime() < new Date(this.form.starTimeStr).getTime()) {
                this.$notify({
                  title: '警告',
                  message: '结束时间不能小于起始时间',
                  type: 'warning',
                  duration: 2000
                });
                return false;
              }
            } else {
              that.form.timeType = 0;
            }
            debugger
            editObj(this.form).then(response => {
              if (response.status === 200) {
                this.bannerDialogVisible = false;
                this.$notify({
                  title: '成功',
                  message: '编辑成功',
                  type: 'success',
                  duration: 2000
                });
                this.getList();
              } else {
                this.$notify({
                  title: '失败',
                  message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
                  type: 'error',
                  duration: 2000
                });
              }
            });
          } else {
            return false;
          }
        });
      },
      /**
       * 上架
       * */
      handleUp(row) {
        this.form = {};
        this.form.id = row.id;
        this.form.status = 1;
        editObj(this.form).then(response => {
          if (response.status === 200) {
            this.bannerDialogVisible = false;
            this.getList();
            this.$notify({
              title: '成功',
              message: '编辑成功',
              type: 'success',
              duration: 2000
            });
          } else {
            this.$notify({
              title: '失败',
              message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
              type: 'error',
              duration: 2000
            });
          }
        });
      },
      /**
       * 下架
       * */
      handleDown(row) {
        this.form = {};
        this.form.id = row.id;
        this.form.status = 2;
        editObj(this.form).then(response => {
          if (response.status === 200) {
            this.bannerDialogVisible = false;
            this.getList();
            this.$notify({
              title: '成功',
              message: '编辑成功',
              type: 'success',
              duration: 2000
            });
          } else {
            this.$notify({
              title: '失败',
              message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
              type: 'error',
              duration: 2000
            });
          }
        });
      },
      /**
       * 上传图片
       * @param file
       * @returns {boolean}
       */
      beforeAvatarUpload(file) {
        const isJPG = file.type === 'image/jpeg' || file.type === 'image/gif';
        const isLt2M = file.size / 1024 / 1024 < 10;

        if (!isJPG) {
          this.$message.error('上传图片只能是 JPG/GIF 格式!');
        }
        if (!isLt2M) {
          this.$message.error('上传图片大小不能超过 10MB!');
        }
        this.showLoadingBody = true;
        return isJPG && isLt2M;
      },
      handleAvatarSuccess(res, file) {
        this.form.picture = res.data;
        this.showLoadingBody = false;
      },
      /**
       * 操作-删除
       * */
      deleteHandler(row) {
        this.$confirm('确定删除吗?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          delObj(row.id).then(response => {
            if (response.status === 200) {
              this.$notify({
                title: '成功',
                message: '删除成功',
                type: 'success',
                duration: 2000
              });
              this.getList();
            } else {
              this.$notify({
                title: '删除失败',
                message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
                type: 'error',
                duration: 2000
              });
            }
          });
        })

      },
    }
  }
</script>
